/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            file.h
 *
 *  Thu Jun  9 15:31:38 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: file.h,v 1.2 2005/06/13 20:38:19 deva Exp $
 */

/*
 * $Log: file.h,v $
 * Revision 1.2  2005/06/13 20:38:19  deva
 * Added some logfile code.
 * Enhanced the file object... now ready to hook into mov_encoder
 *
 * Revision 1.1  2005/06/09 17:54:00  deva
 * New file object, that takes care of uniqueness and counts up number in
 * filename, when grown too big.
 *
 */

#include <config.h>
#ifndef __MIAV_FILE_H__
#define __MIAV_FILE_H__

#include "info.h"

#include <string.h>
using namespace std;

class File {
public:
  File(char *filename, char* ext, Info* info);
  ~File();

  int Write(void* data, int size);

private:
  Info* info;

  int Open();

  int fd;

  int num;
  int seqnum;

  char* filename;
  char* extension;

  int createPath(char* path);
};

#endif/*__MIAV_FILE_H__*/
