/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            info_gui.h
 *
 *  Tue May  3 09:34:59 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id$
 */

/*
 * $Log$
 */

#include <config.h>
#ifndef __MIAV_INFO_GUI_H__
#define __MIAV_INFO_GUI_H__

#ifdef USE_GUI

#define TXT_ERROR_TITLE "Der er opstet en fejl!"
#define TXT_WARNING_TITLE "Advarsel"
#define TXT_INFO_TITLE "Information"

#include "info.h"

#include "miav_config.h"

#include <qwidget.h>
#include <qapplication.h>

#include <pthread.h>
#include <semaphore.h>

#include "messagebox.h"

#define TYPE_SHOW_MESSAGEBOX 65432

class ShowMessageEvent : public QCustomEvent {
public:
  ShowMessageEvent( MessageBox* msgbox )
    : QCustomEvent( TYPE_SHOW_MESSAGEBOX ), m( msgbox ) {}
  MessageBox *messagebox() const { return m; }
private:
  MessageBox *m;;
};

class InfoEventHandler : public QObject {
protected:
  bool eventFilter( QObject *o, QEvent *e );
};


class InfoGui: public Info {
public:
  InfoGui(QApplication *a, QWidget *p, MiavConfig *config);
  ~InfoGui();

  void error(char* fmt, ...);
  void warn(char* fmt, ...);
  void info(char* fmt, ...);

  void setParent(QWidget *p);

private:
  void showmsg(char *msg, char *title, msg_icon icon);

  QApplication *qapp;
  QWidget *parent;
};

#endif/*__MIAV_INFO_GUI_H__*/

#endif/*USE_GUI*/
