/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            mov_encoder_writer.h
 *
 *  Sun May 22 12:51:35 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: mov_encoder_writer.h,v 1.4 2005/06/16 21:28:57 deva Exp $
 */

/*
 * $Log: mov_encoder_writer.h,v $
 * Revision 1.4  2005/06/16 21:28:57  deva
 * Rewrote thread object
 * Fixed bug in mov_encoder (pushed read_sem too many times, whihc lead to
 * growing server queue)
 *
 * Revision 1.3  2005/06/14 12:29:40  deva
 * Incorporated the use of the Info object everywhere... also using the log functionality.
 *
 * Revision 1.2  2005/05/26 12:48:36  deva
 * *** empty log message ***
 *
 * Revision 1.1  2005/05/22 15:49:22  deva
 * Added multithreaded encoding support.
 *
 */

#include <config.h>
#ifndef __MIAV_MOV_ENCODER_WRITER_H__
#define __MIAV_MOV_ENCODER_WRITER_H__

#include "frame.h"
#include "thread.h"
#include "file.h"
#include "info.h"

#include <string>
using namespace std;

class MovEncoderWriter : public Thread {
public:
  MovEncoderWriter(const char* cpr,
                   FramePriorityQueue *q,
                   sem_t *s,
                   pthread_mutex_t *m,
                   Info *info);
  ~MovEncoderWriter();

  void thread_main();

  volatile bool running;

private:
  Info *info;

  File *file;

  FramePriorityQueue *queue;
  pthread_mutex_t *mutex;

  sem_t *sem;

  unsigned int frame_number;
};


#endif/*__MIAV_MOV_ENCODER_WRITER_H__*/
