/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            util.cc
 *
 *  Sun Oct 31 12:12:20 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 * Originally from:
 * RTVideoRec Realtime video recoder and encoder for Linux
 *
 * Copyright (C) 2004  B. Stultiens
 */

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

/*
 * $Id: util.cc,v 1.3 2005/05/03 08:31:59 deva Exp $
 */

/*
 * $Log: util.cc,v $
 * Revision 1.3  2005/05/03 08:31:59  deva
 * Removed the error object, and replaced it with a more generic info object.
 *
 * Revision 1.2  2005/05/01 09:56:26  deva
 * Added Id and Log tags to all files
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "util.h"

void *xmalloc(size_t s)
{
  void *p;
  assert(s > 0);
  
  p = malloc(s);
  if(!p) {
    fprintf(stderr, "Out of memory in xmalloc\n");
    exit(1);
  }
  memset(p, 0, s);
  return p;
}

void *xrealloc(void *b, size_t s)
{
  void *p;
  assert(s > 0);
  
  if(!b) return xmalloc(s);
  
  p = realloc(b, s);
  if(!p) {
    fprintf(stderr, "Out of memory in xrealloc\n");
    exit(1);
  }
  return p;
}
